<template>
    <base-layout :menu-routes="menuRoutes" />
</template>

<script>
import { EventBus } from '@bloomio/spa-admin-common';
import BaseLayout from '@bloomio/spa-admin-common/components/base-layout';
import menuRoutes from '@/constants/ui/menu';

/**
 * The entry point of the spa.
 * Contains notification container and base layout of app
 */
export default {
    name: 'app',
    components: {
        BaseLayout,
    },
    created() {
        EventBus.$on('auth_access_granted', this.getAll);
    },
    data() {
        return {
            menuRoutes,
        };
    },
    computed: {
        token: vm => vm.$store.getters.token,
    },
    methods: {
        /**
         * Init the recieving of data that must be gotten on entering spa.
         */
        getAll() {
            const allPromise = Promise.all([
                this.$store.dispatch('getDictionaries'),
            ]).catch(() => {});
            this.initLoading(allPromise);
            EventBus.$off('auth_access_granted', this.getAll);
        },
    },
};
</script>

<style lang="stylus">
@import './assets/styles/base.styl'

</style>
